diff -r f6ef988fda71 trytond/url.py
--- a/trytond/url.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/url.py	Sun Sep 23 17:30:03 2012 +0200
@@ -8,10 +8,12 @@
 from trytond.config import CONFIG
 from trytond.transaction import Transaction
 
+__all__ = ['URLMixin']
 
-class URLMixin(object):
 
-    def get_url(self):
+class URLAccessor(object):
+
+    def __get__(self, inst, cls):
         from trytond.model import Model
         from trytond.wizard import Wizard
         from trytond.report import Report
@@ -22,17 +24,24 @@
             hostname.split('.'))
 
         url_part = {}
-        if isinstance(self, Model):
+        if issubclass(cls, Model):
             url_part['type'] = 'model'
-        elif isinstance(self, Wizard):
+        elif issubclass(cls, Wizard):
             url_part['type'] = 'wizard'
-        elif isinstance(self, Report):
+        elif issubclass(cls, Report):
             url_part['type'] = 'report'
         else:
             raise NotImplementedError
 
-        url_part['name'] = self._name
+        url_part['name'] = cls.__name__
         url_part['database'] = Transaction().cursor.database_name
 
         local_part = urllib.quote('%(database)s/%(type)s/%(name)s' % url_part)
+        if isinstance(inst, Model) and inst.id:
+            local_part += '/%d' % inst.id
         return 'tryton://%s/%s' % (hostname, local_part)
+
+
+class URLMixin(object):
+
+        __url__ = URLAccessor()
diff -r f6ef988fda71 trytond/webdav/__init__.py
--- a/trytond/webdav/__init__.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/webdav/__init__.py	Sun Sep 23 17:30:03 2012 +0200
@@ -1,3 +1,12 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+from ..pool import Pool
 from .webdav import *
+
+
+def register():
+    Pool.register(
+        Collection,
+        Share,
+        Attachment,
+        module='webdav', type_='model')
